# Fulla

From PanoTools.org Wiki

fulla is a command-line tool distributed with hugin. It can correct chromatic aberration, lens distortion, and vignetting.

## About fulla

fulla is suitable for batch correction of:

Chromatic aberration
  See tutorial in external links.
Lens distortion
  Barrel or pincushion distortion can be corrected using the same a, b, c and d parameters as other Panorama Tools[*] derived programs.
Vignetting
  Polynomial correction by division, addition or flatfield images. hugin contains a vignetting calculator that can use a series of overlapping photographs to determine the likely polynomial required to correct common vignetting problems.

fulla can work with the same range of image types as nona, including 8bit and 16bit TIFF and 32bit floating-point HDR TIFF data.

## Command-line usage

Usage:

      fulla [options] inputfile(s)

The following options can be specified:

- `--green=db|a:b:c:d` or `-g db|a:b:c:d`

Correct radial distortion for all channels. Specify 'db' for database lookup or the 4 coefficients a:b:c:d.

- `--blue=db|a:b:c:d` or `-b db|a:b:c:d`

Correct radial distortion for blue channel, this is applied on top of the `--green` distortion coefficients, use for TCA corr. Specify 'db' for database lookup or the 4 coefficients a:b:c:d.

- `--red=db|a:b:c:d` or `-r db|a:b:c:d`

Correct radial distortion for red channel, this is applied on top of the `--green` distortion coefficients, use for TCA corr. Specify 'db' for database lookup or the 4 coefficients a:b:c:d

- `--camera-maker=Maker` or `-m Maker`

Camera manufacturer, for database query

- `--camera-model=Cam` or `-n Model`

Camera name, for database query

- `--lensname=Lens` or `-l Lens`

Lens name, for database query. Specify `--camera-maker` and `--camera-model` for fixed lens cameras or `--lensname` for interchangeable lenses.

- `--focallength=50` or `-d 50`

Specify focal length in mm, for database query

- `--aperture=3.5` or `-a 3.5`

Specify aperture for vignetting data database query

- `--dont-rescale` or `-s`

Do not rescale the image to avoid black borders.

- `--flatfield=filename` or `-f filename`

Vignetting correction by flatfield division: I = I / c, c = flatfield / mean(flatfield)

- `--vignetting=db|a:b:c:d` or `-c db|a:b:c:d`

Correct vignetting (by division). Specify db for database look up or the the 4 coefficients a:b:c:d: I = I / ( a + b*r^2 + c*r^4 + d*r^6)

- `--linear`

Do vignetting correction in linear color space

- `--gamma=value` or `-i value`

Gamma of input data. used for gamma correction before and after flatfield correction

- `--help` or `-h`

Display help

- `--output=name` or `-o name`

Set output filename. If more than one image is given, the name will be uses as suffix (default suffix: _corr)

- `--compression=value` or `-e value`

Compression of the output files. For jpeg output: 0-100, For tiff output: PACKBITS, DEFLATE, LZW

- `--offset=X:Y` or `-x X:Y`

Horizontal and vertical shift

- `--verbose` or `-v`

Verbose output

## Notes

Finding the correct lens correction parameters can be done using several approaches (see Lens correction model and external links for details). Note parameter d for radial distortion (default 1.0) is not available in GUI frontends - the d mentioned in frontends is typically a different parameter related to image shift.

## Windows batch usage

Once you have calculated fulla parameters as described above, you can create a custom droplet for batch correcting photos like so:

- Create a Shortcut to fulla.exe by dragging the fulla icon to another directory in Windows explorer
- Edit properties
- Change the target to include your correction parameters:

     "C:\Program Files\hugin\fulla.exe" --red=0:0:0.00056:1.00015 --blue=0:0:-0.00026:1.0011 --vignetting=1:0.20:-0.51:0.2

- Rename the shortcut to something descriptive like fulla-peleng
- Now you can correct photos by dragging and dropping them onto the icon

## External links

- Correcting TCA with hugin and fulla
- PTLens database download (April 2006)
  - Lensfun SVN includes parameters for many more lenses
- How to determine lens correction parameters - from Lensfun documentation

Retrieved from "https://wiki.panotools.org/index.php?title=Fulla&oldid=15918"